Package: ZIPLDA
Type: Package
Title: Classifying NGS data package
Version: 0.1.0
Date: 2017-12-23
Author: Zhou Yan
Maintainer: Zhou Yan <zhouy1016@szu.edu.cn>
Description: Classifying next-generation sequencing data using a zero-inflated Poisson model.
Imports: PoiClaClu
License: GPL-2
Encoding: UTF-8
LazyData: true
NeedsCompilation: no
Packaged: 2017-12-23 11:17:42 UTC; Administrator

.calcFactorWeighted <- function(obs, ref, logratioTrim=.3, sumTrim=0.05, doWeighting=TRUE, Acutoff=-1e10) {

  if( all(obs==ref) )
    return(1)

  nO <- sum(obs)
  nR <- sum(ref)
  logR <- log2((obs/nO)/(ref/nR))          # log ratio of expression, accounting for library size
  absE <- (log2(obs/nO) + log2(ref/nR))/2  # absolute expression
  v <- (nO-obs)/nO/obs + (nR-ref)/nR/ref   # estimated asymptotic variance

  # remove infinite values, cutoff based on A
  fin <- is.finite(logR) & is.finite(absE) & (absE > Acutoff)

  logR <- logR[fin]
  absE <- absE[fin]
  v <- v[fin]

  # taken from the original mean() function
  n <- sum(fin)
  loL <- floor(n * logratioTrim) + 1
  hiL <- n + 1 - loL
  loS <- floor(n * sumTrim) + 1
  hiS <- n + 1 - loS

  keep <- (rank(logR) %in% loL:hiL) & (rank(absE) %in% loS:hiS)
  if (doWeighting)
    2^( sum(logR[keep]/v[keep], na.rm=TRUE) / sum(1/v[keep], na.rm=TRUE) )
  else
    2^( mean(logR[keep], na.rm=TRUE) )
}

ZIPLDA<-
  function(x,y,xte=NULL,rho=0,beta=1,rhos=NULL,prob0=NULL,
           type=c("mle","deseq","quantile"), prior=NULL,
           transform=TRUE, alpha=NULL){
    if(is.null(xte)){
      xte <- x
      warning("Since no xte was provided, testing was performed on training data set.")
    }
    if(!is.null(rho) && length(rho)>1) stop("Can only enter 1 value of rho. If you would like to enter multiple values, use rhos argument.")
    type <- match.arg(type)
    if(!transform && !is.null(alpha)) stop("You have asked for NO transformation but have entered alpha.")
    if(transform && is.null(alpha)) alpha <- FindBestTransform(x)
    if(transform){
      if(alpha<=0 || alpha>1) stop("alpha must be between 0 and 1")
      x <- x^alpha
      xte <- xte^alpha
    }
    if(is.null(prior)) prior <- rep(1/length(unique(y)), length(unique(y)))
    if(is.null(rho)&&is.null(rhos)) stop("Must enter rho or rhos.")
    null.out <- NullModel(x, type=type)
    ns <- null.out$n
    nste <- NullModelTest(null.out,x,xte,type=type)$nste
    uniq <- sort(unique(y))
    signx<-sign(xte==0)
    if(is.null(rhos)){
      ds <- GetD(ns,x,y,rho,beta)
      discriminant <- matrix(NA, nrow=nrow(xte), ncol=length(uniq))
      for(k in 1:length(uniq)){
        #discriminant[,k] <- rowSums(scale(xte,center=FALSE,scale=(1/log(ds[k,])))) - rowSums(scale(nste,center=FALSE,scale=(1/ds[k,]))) + log(prior[k])
        for(i in 1:nrow(xte)){
          dstar = ds[k,]
          part2=nste[i,]*dstar
          part1=prob0[i,]+(1-prob0[i,])*exp(-part2)
          part1[part1==0]=1
          discriminant[i,k] <-sum(signx[i,]*log(part1))+sum(xte[i,]*(1-signx[i,])*log(dstar))-sum((1-signx[i,])*part2)+log(prior[k])

        }
      }
      save <- list(ns=ns,nste=nste,ds=ds,discriminant=discriminant,ytehat=uniq[apply(discriminant,1,which.max)], alpha=alpha, rho=rho,x=x,y=y,xte=xte,alpha=alpha,type=type)
      class(save) <- "poicla"
      return(save)
    } else {
      save <- list()
      ds.list <- GetD(ns,x,y,rho=NULL, rhos=rhos,beta)
      for(rho in rhos){
        ds <- ds.list[[which(rhos==rho)]]
        discriminant <- matrix(NA, nrow=nrow(xte), ncol=length(uniq))
        for(k in 1:length(uniq)){
          for(i in 1:nrow(xte))   {

            dstar = ds[k,]
            part2=nste[i,]*dstar
            part1=prob0[i]+(1-prob0[i])*exp(-part2)
            part1[part1==0]=1
            discriminant[i,k] <-sum(signx[i,]*log(part1))+sum(xte[i,]*(1-signx[i,])*log(dstar))-sum((1-signx[i,])*part2)+log(prior[k])

          }

          #discriminant[,k] <- rowSums(scale(xte,center=FALSE,scale=(1/log(ds[k,])))) - rowSums(scale(nste,center=FALSE,scale=(1/ds[k,]))) + log(prior[k])
        }
        save[[which(rhos==rho)]] <- (list(ns=ns,nste=nste,ds=ds,discriminant=discriminant,ytehat=uniq[apply(discriminant,1,which.max)], alpha=alpha, rho=rho,x=x,y=y,xte=xte,type=type))
      }
      class(save) <- "poicla"
      return(save)
    }
  }

#estimate probablity of 0 with Logist regression

estp1<-function(x,testx){
  G<-length(x[1,])
  lib<-rowSums(x)
  x1<-t(x)
  testx1<-t(testx)
  librep<-rep(lib,rep(G,length(lib)))/mean(lib)
  x2<-as.vector(x1)
  testx2<-as.vector(testx1)

  y<-x2
  y[y!=0]<-1
  xreg<-cbind(y,librep,x2)
  glm.out<-glm(y~ librep+ x2,family=binomial("logit"),data=data.frame(xreg))
  summary(glm.out)


  coef<-as.matrix(glm.out$coefficients)
  inter<-rep(1,G)
  libsize<-rep(sum(x1[,1]),G)/mean(lib)
  estx1<-cbind(inter,libsize,x1[,1])
  p<-exp(estx1%*% coef)/(1+exp(estx1%*% coef))


  estx1[1:2,]%*%coef

  dim(estx1)

  dim(xreg[1:5,])
  num0<-apply(x==0,1,sum)
  probp<-apply(exp(-x),1,sum)-num0
  p<-(num0-probp)/(G-probp)
  p[num0<probp]<-0
  return(p)
}

calcNormFactors <- function(dataMatrix, refColumn=1, logratioTrim=.3, sumTrim=0.05, doWeighting=TRUE, Acutoff=-1e10) {
  if( !is.matrix(dataMatrix) )
    stop("'dataMatrix' needs to be a matrix")
  if( refColumn > ncol(dataMatrix) )
    stop("Invalid 'refColumn' argument")
  apply(dataMatrix,2,.calcFactorWeighted,ref=dataMatrix[,refColumn], logratioTrim=logratioTrim,
        sumTrim=sumTrim, doWeighting=doWeighting, Acutoff=Acutoff)
}

CountDataSet2 <- function(n, p, K, param, sdsignal, drate)
{
  if (n < 4 * K)
    stop("We require n to be at least 4*K.")
  q0 <- rexp(p, rate = 1/25)

  isDE <-  runif(p)< drate    #runif(p)
  classk <- matrix(NA, nrow = K, ncol = p)
  for (k in 1:K) {
    lfc <- rnorm(p, sd = sdsignal)
    classk[k, ] <- ifelse(isDE, q0 * exp(lfc), q0)
  }
  truesf <- runif(n) * 2 + 0.2
  truesfte <- runif(n) * 2 + 0.2
  conds <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  condste <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  x <- xte <- matrix(NA, nrow = n, ncol = p)
  dispersion <-round(runif(p)*param+0.5)
  dispersion <- rep(param,p)
  for(j in 1:p){
    for (i in 1:n) {
      for (k in 1:K) {
        if (conds[i] == k)
          x[i, j] <- rnbinom(1, mu = truesf[i] * classk[k,j], size = dispersion[j])
        if (condste[i] == k)
          xte[i,j] <- rnbinom(1, mu = truesfte[i] * classk[k,j], size =  dispersion[j])
      }
    }
  }
  rm <- apply(x, 2, sum) == 0
  return(list(x = x[, !rm], xte = xte[, !rm], y = conds, yte = condste,
              truesf = truesf, truesfte = truesfte, dkg=classk))
}

balanced.folds <- function(y, nfolds = min(min(table(y)), 10)){
  totals <- table(y)
  fmax <- max(totals)
  nfolds <- min(nfolds, fmax)
  # makes no sense to have more folds than the max class size
  folds <- as.list(seq(nfolds))
  yids <- split(seq(y), y)
  # nice way to get the ids in a list, split by class
  ###Make a big matrix, with enough rows to get in all the folds per class
  bigmat <- matrix(NA, ceiling(fmax/nfolds) * nfolds, length(totals))
  for(i in seq(totals)) {
    bigmat[seq(totals[i]), i] <- sample(yids[[i]])
  }
  smallmat <- matrix(bigmat, nrow = nfolds) # reshape the matrix
  ### Now do a clever sort to mix up the NAs
  smallmat <- permute.rows(t(smallmat)) ### Now a clever unlisting
  x <- apply(smallmat, 2, function(x) x[!is.na(x)])
  if(is.matrix(x)){
    xlist <- list()
    for(i in 1:ncol(x)){
      xlist[[i]] <- x[,i]
    }
    return(xlist)
  }
  return(x)
}

CountDataSet1 <- function (n, p, K, param, sdsignal, drate)
{
  if (n < 4 * K)
    stop("We require n to be at least 4*K.")
  q0 <- rexp(p, rate = 1/25)

  isDE <-  runif(p)< drate    #runif(p)
  classk <- matrix(NA, nrow = K, ncol = p)
  for (k in 1:K) {
    lfc <- rnorm(p, sd = sdsignal)
    classk[k, ] <- ifelse(isDE, q0 * exp(lfc), q0)
  }
  truesf <- runif(n) * 2 + 0.2
  truesfte <- runif(n) * 2 + 0.2
  conds <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  condste <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  x <- xte <- matrix(NA, nrow = n, ncol = p)
  prob<- runif(n,0.05,0.5)
  for (i in 1:n) {
    for (k in 1:K) {
      if (conds[i] == k)
        x[i, ] <- rnbinom(p, mu = truesf[i] * classk[k, ], size = param)
      ind0<-which(rank(x[i, ])<round(p*prob[i]))
      #ind0<-sample(1:p, round(p*prob[i]), replace = FALSE)
      x[i,ind0] <-0
      if (condste[i] == k)
        xte[i, ] <- rnbinom(p, mu = truesfte[i] * classk[k, ], size = param)
      ind0<-which(rank(xte[i, ])<round(p*prob[i]))
      #ind0<-sample(1:p, round(p*prob[i]), replace = FALSE)
      xte[i,ind0] <-0
    }
  }
  rm <- apply(x, 2, sum) == 0
  return(list(x = x[, !rm], xte = xte[, !rm], y = conds, yte = condste,
              truesf = truesf, truesfte = truesfte, dkg=classk))
}

print.poiclacv <- function(x,...){
  if(!is.null(x$alpha)) cat("Value of alpha used to transform data: ", x$alpha, fill=TRUE)
  if(is.null(x$alpha)) cat("No transformation performed.",fill=TRUE)
  cat("Rho values considered: ", round(x$rhos,3), fill=TRUE)
  cat("Number of CV folds performed: ", length(x$folds), fill=TRUE)
  cat("Type of normalization performed: ", x$type, fill=TRUE)
  nnonzero.mean <- round(apply(x$nnonzero, 2, mean),3)
  err.mean <- round(apply(x$errs, 2, mean),3)
  cat(fill=TRUE)
  cat("CV results:", fill=TRUE)
  mat <- cbind(round(x$rhos,3), err.mean,nnonzero.mean)
  mat <- rbind(c("Rho", "Errors", "Num. Nonzero Features"), mat)
  write.table(mat, sep="\t", quote=FALSE, row.names=FALSE, col.names=FALSE)
}

estimatep<-function(x,y,xte=NULL,beta=1,type=c("mle","deseq","quantile"), prior=NULL){
  if(is.null(xte)){
    xte <- x
    warning("Since no xte was provided, testing was performed on training data set.")
  }
  type <- match.arg(type)
  if(is.null(prior)) prior <- rep(1/length(unique(y)), length(unique(y)))

  null.out <- NullModel(x, type=type)
  ns <- null.out$n
  nste <- NullModelTest(null.out,x,xte,type=type)$nste
  uniq <- sort(unique(y))
  signx<-sign(xte==0)
  ds <-  GetDn(ns,x,y,beta)

  mu <- matrix(NA, nrow=nrow(x), ncol=length(x[1,]))
  # for(k in 1:length(y)){
  for(i in 1:nrow(x)){
    dstar = ds[y[i],]
    mu[i,]<-nste[i,]*dstar
  }
  #}
  #mu1<-t(mu)


  G<-length(x[1,])
  lib<-rowSums(x)
  x1<-t(x)
  #stx1<-t(testx)

  mu1<-as.vector(t(mu))
  librep<-rep(lib,rep(G,length(lib)))/(lib[1])
  x2<-as.vector(x1)

  y<-x2
  y[y!=0]<-1
  xreg<-cbind(y,librep,mu1)
  glm.out<-glm(y~ librep+ mu1,family=binomial("logit"),data=data.frame(xreg))
  summary(glm.out)

  coef<-as.matrix(glm.out$coefficients)
  inter<-rep(1,G)
  #libsize<-rep(sum(x1[,2]),G)/lib[1]
  muu<-t(mu)
  #estx1<-cbind(inter,libsize,muu[,1])
  #p<-exp(estx1%*% coef)/(1+exp(estx1%*% coef))


  xte1=t(xte)
  p<-xte1
  for(i in 1:length(xte1[1,])){
    libsize<-rep(sum(xte1[,i]),G)/lib[1]
    estx1<-cbind(inter,libsize,muu[,1])
    dd<-estx1%*% coef
    dd[dd>50]<-50
    dd[dd<(-50)]<--50
    p1<-exp(dd)/(1+exp(dd))
    p[,i]<-1-p1
  }
  return(p)
}

print.poicla <- function(x,...){
  if(is.null(x$rhos) && is.null(x$rho)){
    if(!is.null(x[[1]]$alpha)) cat("Value of alpha used to transform data: ", x[[1]]$alpha, fill=TRUE)
    if(is.null(x[[1]]$alpha)) cat("No transformation performed.", fill=TRUE)
    cat("Type of normalization performed: ", x[[1]]$type, fill=TRUE)
    cat("Number of training observations: ", nrow(x[[1]]$x), fill=TRUE)
    if(!is.null(x[[1]]$xte)) cat("Number of test observations: ", nrow(x[[1]]$xte), fill=TRUE)
    cat("Number of features: ", ncol(x[[1]]$x), fill=TRUE)
    cat("-------------------------", fill=TRUE)
    cat("-------------------------", fill=TRUE)
    for(i in 1:length(x)){
      cat("-------------------------", fill=TRUE)
      cat("Value of rho used: ", x[[i]]$rho, fill=TRUE)
      cat("Number of features used in classifier: ", sum(apply(x[[i]]$ds!=1, 2, sum)!=0), fill=TRUE)
      if(sum(apply(x[[i]]$ds!=1, 2, sum)!=0)<100) cat("Indices of features used in classifier: ", which(apply(x[[i]]$ds!=1, 2, sum)!=0), fill=TRUE)
    }
  } else {
    if(!is.null(x$alpha)) cat("Value of alpha used to transform data: ", x$alpha, fill=TRUE)
    if(is.null(x$alpha)) cat("No transformation performed.", fill=TRUE)
    cat("Type of normalization performed: ", x$type, fill=TRUE)
    cat("Number of training observations: ", nrow(x$x), fill=TRUE)
    if(!is.null(x$xte)) cat("Number of test observations: ", nrow(x$xte), fill=TRUE)
    cat("Number of features: ", ncol(x$x), fill=TRUE)
    cat("Value of rho used: ", x$rho, fill=TRUE)
    cat("Number of features used in classifier: ", sum(apply(x$ds!=1, 2, sum)!=0), fill=TRUE)
    if(sum(apply(x$ds!=1, 2, sum)!=0)<100) cat("Indices of features used in classifier: ", which(apply(x$ds!=1, 2, sum)!=0), fill=TRUE)
  }
}

GetD <- function(ns, x, y, rho,beta,rhos=NULL){
  if(!is.null(rho) && !is.null(rhos)) stop("do you want to use rho or rhos in GetD function???")
  if(is.null(rhos)){
    uniq <- sort(unique(y))
    ds <- matrix(1, nrow=length(uniq), ncol=ncol(x))
    for(k in 1:length(uniq)){
      a <- colSums(x[y==uniq[k],])+beta
      b <- colSums(ns[y==uniq[k],])+beta
      ds[k,] <- 1+Soft(a/b-1,rho/sqrt(b))
    }
    return(ds)
  } else {
    uniq <- sort(unique(y))
    ds.list <- list()
    for(rho in rhos){
      ds <- matrix(1, nrow=length(uniq), ncol=ncol(x))
      for(k in 1:length(uniq)){
        a <- colSums(x[y==uniq[k],])+beta
        b <- colSums(ns[y==uniq[k],])+beta
        ds[k,] <- 1+Soft(a/b-1,rho/sqrt(b))
      }
      ds.list[[which(rhos==rho)]] <- ds
    }
    return(ds.list)
  }
}

GetDn <- function(ns, x, y, beta){
  uniq <- sort(unique(y))
  ds <- matrix(1, nrow=length(uniq), ncol=ncol(x))
  for(k in 1:length(uniq)){
    a <- colSums(x[y==uniq[k],])+beta
    b <- colSums(ns[y==uniq[k],])+beta
    ds[k,] <- a/b
  }
  return(ds)
}

ZIPDA.cv <-
  function(x,y,rhos=NULL,beta=1,nfolds=5,prob0=NULL,type=c("mle","deseq","quantile"),folds=NULL,transform=TRUE, alpha=NULL, prior=NULL){
    type <- match.arg(type)
    if(!transform && !is.null(alpha)) stop("You have asked for NO transformation but have entered alpha.")
    if(transform && is.null(alpha)) alpha <- FindBestTransform(x)
    if(transform){
      if(alpha<=0 || alpha>1) stop("alpha must be between 0 and 1")
      x <- x^alpha
    }
    if(is.null(rhos)){
      ns <- NullModel(x,type=type)$n
      uniq <- sort(unique(y))
      maxrho <- rep(NA, length(uniq))
      for(k in 1:length(uniq)){
        a <- colSums(x[y==uniq[k],])+beta
        b <- colSums(ns[y==uniq[k],])+beta
        maxrho[k] <- max(abs(a/b-1)*sqrt(b),na.rm=TRUE)
      }
      rhos <- seq(0, max(maxrho,na.rm=TRUE)*(2/3), len=30)
    }
    if(is.null(folds)) folds <- balanced.folds(y,nfolds=nfolds)
    nfolds <- length(folds)
    errs <- nnonzero <- matrix(NA, nrow=nfolds, ncol=length(rhos))
    for(i in 1:nfolds){
      cat(i,fill=FALSE)
      tr <- -folds[[i]]
      te <- folds[[i]]
      out <- ZIPLDA(x[tr,],y[tr],x[te,],rhos=rhos,beta=beta,prob0=prob0,type="mle", prior=prior, transform=FALSE) # Have already power-transformed x, so don't need to do it again!!!
      for(j in 1:length(rhos)){
        errs[i,j] <- sum(out[[j]]$ytehat!=y[te])
        nnonzero[i,j] <- sum(colSums(out[[j]]$ds!=1)!=0)
      }
    }
    cat(fill=TRUE)
    save <- list(errs=errs, bestrho=rhos[max(which(colMeans(errs)==min(colMeans(errs))))], rhos=rhos, nnonzero=nnonzero,folds=folds, alpha=alpha,type=type)
    class(save) <- "poiclacv"
    return(save)
  }

classZIP<-function(x,y,xte=NULL,beta=1,prob=NULL,prob0=NULL,type=c("mle","deseq","quantile"), prior=NULL, transform=TRUE, alpha=NULL){
  if(is.null(xte)){
    xte <- x
    warning("Since no xte was provided, testing was performed on training data set.")
  }
  type <- match.arg(type)
  if(!transform && !is.null(alpha)) stop("You have asked for NO transformation but have entered alpha.")
  if(transform && is.null(alpha)) alpha <- FindBestTransform(x)
  if(transform){
    if(alpha<=0 || alpha>1) stop("alpha must be between 0 and 1")
    x <- x^alpha
    xte <- xte^alpha
  }
  if(is.null(prior)) prior <- rep(1/length(unique(y)), length(unique(y)))
  null.out <- NullModel(x, type=type)
  ns <- null.out$n
  nste <- NullModelTest(null.out,x,xte,type=type)$nste
  uniq <- sort(unique(y))
  signx<-sign(xte==0)
  if(is.null(prob0)){
    ds <- GetDn(ns,x,y,beta)
    discriminant <- matrix(NA, nrow=nrow(xte), ncol=length(uniq))
    for(k in 1:length(uniq)){
      discriminant[,k] <- rowSums(scale(xte,center=FALSE,scale=(1/log(ds[k,])))) - rowSums(scale(nste,center=FALSE,scale=(1/ds[k,]))) + log(prior[k])
    }
    save <- list(ns=ns,nste=nste,ds=ds,discriminant=discriminant,ytehat=uniq[apply(discriminant,1,which.max)], alpha=alpha,x=x,y=y,xte=xte,alpha=alpha,type=type)
    class(save) <- "poicla"
    return(save)
  }else{
    ds<- GetDn(ns,x,y, beta)
    discriminant <- matrix(NA, nrow=nrow(xte), ncol=length(uniq))
    discriminant1 <- matrix(NA, nrow=nrow(xte), ncol=length(uniq))
    #discriminant[,k] <- rowSums(scale(xte,center=FALSE,scale=(1/log(ds[k,])))) - rowSums(scale(nste,center=FALSE,scale=(1/ds[k,]))) + log(prior[k])
    for(i in 1:nrow(xte))   {
      if(prob0[i]==0){

        for(k in 1:length(uniq)){
          discriminant1[,k] <- rowSums(scale(xte,center=FALSE,scale=(1/log(ds[k,])))) - rowSums(scale(nste,center=FALSE,scale=(1/ds[k,]))) + log(prior[k])
        }
        discriminant[i,]<-discriminant1[i,]
      }else{
        for(k in 1:length(uniq)){
          dstar = ds[k,]
          part2=nste[i,]*dstar
          part1=prob0[i]+(1-prob0[i])*exp(-part2)
          part1[part1==0]=1
          part2[part2==0]=1
          discriminant[i,k] <-sum(signx[i,]*log(part1))+sum(xte[i,]*(1-signx[i,])*log(dstar))-sum((1-signx[i,])*part2)+log(prior[k])
        }
      }

    }

    save <- list(ns=ns,nste=nste,ds=ds,discriminant=discriminant,ytehat=uniq[apply(discriminant,1,which.max)], alpha=alpha, x=x,y=y,xte=xte,alpha=alpha,type=type)
    class(save) <- "poicla"
    return(save)
  }
}

\name{ZIPDA.cv}
\alias{ZIPDA.cv}
\title{Hello, World!}
\usage{
  ZIPDA.cv(x,y,rhos=NULL,beta=1,nfolds=5,prob0=NULL,
  type=c("mle","deseq","quantile"),folds=NULL,
  transform=TRUE, alpha=NULL, prior=NULL)
}
\description{
  Prints 'Hello, world!'.
}
\keyword{internal}

\name{ZIPLDA-package}
\alias{ZIPLDA-package}
\docType{package}
\title{
  A approach using a zero-inflated Poisson model to classify next-generation sequencing data.
}
\description{
  The main idea of ZIPLDA
  is that since RNA-seq data with an excess of zeros, then we assumes that the data are from a mixturn of two distributions: one is a point mass at zero, and the other follows a Poisson distribution, and consider a logistic relation between the probability of observing zeros and the mean of the genes and the sequencing depth in the model.

}
\author{
  Yan Zhou

  Maintainer:Yan Zhou <zhouy1016@szu.edu.cn>
}
\references{
  Yan Zhou, Xiang Wan, Baoxue Zhang and Tiejun Tong (2017). Classifying next-generation sequencing data using a zero-inflated Poisson model.
}
\keyword{ package }
\seealso{
  ?ZIPLDA
}
\examples{
  set.seed(1)
dat <- CountDataSet1(n=40,p=50,sdsignal=0.2,K=2,
param=1/0.001,drate=0.2)

prob<-estimatep(dat$x,dat$y,xte=dat$x,beta=1,
type=c("mle","deseq","quantile"), prior=NULL)

prob0<-estimatep(dat$x,dat$y,dat$xte,beta=1,
type=c("mle","deseq","quantile"), prior=NULL)

prob<-t(prob)
prob0<-t(prob0)

zipldacv.out <- ZIPDA.cv(dat$x,dat$y,prob0=prob)

ZIPLDA(dat$x,dat$y,dat$xte,transform=FALSE,
prob0=prob0,rho=zipldacv.out$bestrho)
}

\name{ZIPLDA}
\alias{ZIPLDA}
\title{Classifying next-generation sequencing data using
  a zero-inflated Poisson model}
\description{
  A method to classify next-generation sequencing data using
  a zero-inflated Poisson model.
}

\usage{
  ZIPLDA(x,y,xte=NULL,rho=0,beta=1,rhos=NULL,prob0=NULL,
           type=c("mle","deseq","quantile"), prior=NULL,
           transform=TRUE, alpha=NULL)
}

\arguments{
  \item{x}{Training data set.
  }
  \item{y}{A vector shows each sample in training set belongs to which class.
  }
  \item{xte}{Test data set, if not provide, testing was performed on training data set.
  }
  \item{rho}{Default value is 0.
  }
  \item{beta}{A prior value to estimate class differences, default is 1.
  }
  \item{rhos}{A vector rho can choose.
  }
  \item{prob0}{The probability of the point mass at zero.
  }
  \item{type}{There are three types to choose to estimate size factor, that is "mle", "deseq" and "quantile".
  }
  \item{prior}{A prior to calculate discriminant score, if NULL, the value is equall to the proportion that the number of samples belong to the k-th class to total sample numbers.
  }
  \item{transform}{Asking for if transformation, default is TRUE.
  }
  \item{alpha}{A value must be between 0 and 1.
  }
}

\value{An object of class "ZIPLDA" is a list containing at least the following components:

  \item{ns}{The product of Size factor and the total count of short reads of gene g for the training data.
    }
  \item{nste}{The product of Size factor and the total count of short reads of gene g for the test data.
  }
  \item{ds}{Estimated class differences.
  }
  \item{discriminant}{Discriminant matrix.
  }
  \item{ytehat}{The class that samples in test data set belongs to.
  }
  \item{...}{Parameters explained in arguments.
  }
}
\seealso{?ZIPLDA()}
\examples{
set.seed(1)
dat <- CountDataSet1(n=40,p=50,sdsignal=0.2,K=2,
param=1/0.001,drate=0.2)

prob<-estimatep(dat$x,dat$y,xte=dat$x,beta=1,
type=c("mle","deseq","quantile"), prior=NULL)

prob0<-estimatep(dat$x,dat$y,dat$xte,beta=1,
type=c("mle","deseq","quantile"), prior=NULL)

prob<-t(prob)
prob0<-t(prob0)

zipldacv.out <- ZIPDA.cv(dat$x,dat$y,prob0=prob)

ZIPLDA(dat$x,dat$y,dat$xte,transform=FALSE,
prob0=prob0,rho=zipldacv.out$bestrho)
}

\name{estimatep}
\alias{estimatep}
\title{Estimation the zero distribution probability}
\description{
  This function is to estimate the zero distribution probability.
}

\usage{
  estimatep(x,y,xte=NULL,beta=1,type=c("mle","deseq","quantile"), prior=NULL)
}

\arguments{
  \item{x}{A matrix or data.frame for training data.
  }
  \item{y}{A vector shows each sample in training set belongs to which class.
  }
  \item{xte}{A matrix or data.frame for test data. If equalls to NULL, testing will be performed on training data set.
  }
  \item{beta}{
  }
  \item{type}{There are three types can choose,
  }
  \item{prior}{Prior probability to calculate zero distribution probability, default is NULL, that is each class has equall prior probability.
  }
}

\value{
  \item{p}{The probability of zero distribution.

  }
}
\seealso{?estimatep()}

\keyword{internal}

\name{CountDataSet1}
\alias{CountDataSet1}
\title{Simulation data for binary classification.}
\description{
Generation a dataset for binary classification.
}

\usage{
CountDataSet1(n, p, K, param, sdsignal, drate)
}

\arguments{
  \item{n}{Total number of samples in training/test set for all classes.
}
  \item{p}{The number of features in each samples.
}
  \item{K}{Number of classes.
}
  \item{param}{One of parameter for negative binomial distribution, which is the reciprocal of
phi.
}
  \item{sdsignal}{One of parameter for normal distribution, which is the standard deviation.
}
  \item{drate}{The proportion for the differentially expressed genes.
  }
}

\value{An object of class "CountDataSet1" is a list containing at least the following components:

\item{x}{Simulation training set which is a n by p matrix.
 }
\item{xte}{Simulation test set which is also a n by p matrix.

}
\item{y}{A vector shows each sample in training set belongs to which class.

}
\item{yte}{A vector shows each sample in test set belongs to which class.

}
\item{truesf}{A vector shows the true size factor for training set.

}
\item{truesfte}{A vector shows the true size factor for test set.
}
\item{dkg}{A k by p matrix that is prepared for calculate the expectation for negative binomial distribution.
}
}
\seealso{?CountDataSet1()}
\keyword{internal}

\name{calcNormFactors}
\alias{calcNormFactors}
\title{Hello, World!}
\usage{
  calcNormFactors(dataMatrix, refColumn=1,
                  logratioTrim=.3, sumTrim=0.05,
                  doWeighting=TRUE, Acutoff=-1e10)
}
\description{
  Prints 'Hello, world!'.
}
\keyword{internal}

\name{estimatep1}
\alias{estimatep1}
\title{Hello, World!}
\usage{
  estimatep1(x,y,xte=NULL,beta=1,type=c("mle","deseq","quantile"), prior=NULL)
}
\description{
  Prints 'Hello, world!'.
}
\keyword{internal}

\name{.calcFactorWeighted}
\alias{.calcFactorWeighted}
\title{Hello, World!}
\usage{
  .calcFactorWeighted(obs, ref, logratioTrim=.3,
  sumTrim=0.05, doWeighting=TRUE, Acutoff=-1e10)
}
\description{
  Prints 'Hello, world!'.
}
\keyword{internal}

\name{CountDataSet2}
\alias{CountDataSet2}
\title{Simulation data for multiple classification.}
\description{
  Generation a dataset for multiple classification.
}

\usage{
  CountDataSet2(n, p, K, param, sdsignal, drate)
}

\arguments{
  \item{n}{Total number of samples for all classes.
  }
  \item{p}{The number of features in each samples.
  }
  \item{k}{Number of classes.
  }
  \item{param}{One of parameter for negative binomial distribution, which is the reciprocal of
    phi.
  }
  \item{sdsignal}{One of parameter for normal distribution, which is the standard deviation.
  }
  \item{drate}{The proportion for the differentially expressed genes.
  }
}

\value{An object of class "CountDataSet2" is a list containing at least the following components:

    \item{x}{Simulation training set which is a n by p matrix.
    }
  \item{xte}{Simulation test set which is also a n by p matrix.

  }
  \item{y}{A vector shows each sample in training set belongs to which class.

  }
  \item{yte}{A vector shows each sample in test set belongs to which class.

  }
  \item{truesf}{The true size factor for training set.

  }
  \item{truesfte}{The true size factor for test set.
  }
  \item{dkg}{A k by p matrix that is prepared for calculate the expectation for negative binomial distribution.
  }
}
\seealso{?CountDataSet2()}
\keyword{internal}

\name{classZIP}
\alias{classZIP}
\title{Hello, World!}
\usage{
  classZIP(x,y,xte=NULL,beta=1,prob=NULL,prob0=NULL,
  type=c("mle","deseq","quantile"), prior=NULL,
  transform=TRUE, alpha=NULL)
}
\description{
  Prints 'Hello, world!'.
}
\keyword{internal}
